#!/bin/sh
# EPG-scan
# Wayne?

PID_FILE=/var/run/EPG-scan.pid
if [ -e $PID_FILE ]; then
 rm -rf $PID_FILE >/dev/null 2>&1
 exit
fi
touch $PID_FILE

# test parameter 
[ "$1" -ge 0 2>/dev/null ] && WAIT_ZAP=$1 || WAIT_ZAP=17

# Get nhttpd's options
CTRL_FILE="/var/tuxbox/config/nhttpd.conf"
CTRL_PORT="$(cat $CTRL_FILE 2>/dev/null | sed -n 's/^WebsiteMain.port= *\(.*\) */:\1/p')"
CTRL_USER="$(cat $CTRL_FILE 2>/dev/null | sed -n 's/^mod_auth.username= *\(.*\) */\1/p')"
CTRL_PASS="$(cat $CTRL_FILE 2>/dev/null | sed -n 's/^mod_auth.password= *\(.*\) */\1/p')"
[ -n "$CTRL_USER" -a -n "$CTRL_PASS" ] && CTRL_AUTH="${CTRL_USER}:${CTRL_PASS}@"
CTRL_ZAP="http://${CTRL_AUTH}127.0.0.1${CTRL_PORT}/control/"

# Show on TV
msg() {
 [ $# -lt 2 ] && return 1
 [ "$1" == "popup" -o "$1" == "nmsg" ] && msg_mode="$1"
 [ -z "$msg_mode" ] && return 1
 shift
 echo WGET "${CTRL_ZAP}message?${msg_mode}=$(echo $*|sed 's/ /%20/g')"
 wget -q -O - "${CTRL_ZAP}message?${msg_mode}=$(echo $*|sed 's/ /%20/g')" >/dev/null 2>&1
}

# Log to VFD & Console
log() {
 echo "$*"
 fp_control --settext "$*" >/dev/null
}

#channels
CHAN_NUM=0
CHAN_CFG=/var/plugins/EPG-scan.conf
CHAN_CNT="$(grep -vE "^ *$|^ *#" "$CHAN_CFG" 2>/dev/null | wc -l)"
if [ "$CHAN_CNT" -le 0 ]; then
	log "No channels defined!"
	sleep 3
	rm -rf $PID_FILE >/dev/null 2>&1
	return
fi
[ "$CHAN_CNT" -le 9 ] && CHAN_DEC="0"

#initial
msg popup "EPG-scan durchsucht ${CHAN_CNT} Sender%0A%0AZum beenden Plugin nochmals starten"
log "EPG-scan: ${CHAN_CNT}chs"
CHAN_CUR="$(wget -q ${CTRL_ZAP}zapto -O - 2>&1)"

#mainloop
sleep 2
WAIT_MUL=$(((($WAIT_ZAP-1)/10)+1))
while read line; do
 echo "$line" | grep -qE "^ *$|^ *#" && continue
 let CHAN_NUM++
 [ "$CHAN_NUM" -lt 10 ] && _trailing="0" || _trailing=""
 _message="$_trailing$CHAN_NUM/$CHAN_DEC$CHAN_CNT: "
 log "$_message$line"
 if [ "$(/usr/local/bin/pzapit -n "$line")" == "channel not found." ]; then
  msg nmsg "EPG-scan konnte $line nicht finden"
  log "EPG-scan: zapping to $line failed"
  sleep 1
  continue
 fi
 _waiting=0
 while [ "$_waiting" -lt $WAIT_ZAP ]; do
  sleep 1
  [ $(($_waiting/$WAIT_MUL*$WAIT_MUL)) -eq $_waiting ] && _message="$_message."
  log $_message
  let _waiting++
  [ -e $PID_FILE ] || break
 done
 [ -e $PID_FILE ] || break
 sleep 1
done < "$CHAN_CFG"

#final
[ -n "$CHAN_CUR" ] && wget -q ${CTRL_ZAP}zapto?$CHAN_CUR -O - >/dev/null 2>&1
sleep 2
if [ -e $PID_FILE ]; then
 rm -rf $PID_FILE >/dev/null 2>&1
 msg nmsg "EPG-scan abgeschlossen"
 log "EPG-scan: fertig"
else
 msg popup "EPG-scan abgebrochen"
 log "EPG-scan:abbruch"
fi
